"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildTokenId = exports.isNativeCosmWasmDenom = exports.isNativeDenomInjective = void 0;
var utils_1 = require("ethers/lib/utils");
var terra_1 = require("../terra");
var utils_2 = require("../utils");
var isNativeDenomInjective = function (string) {
    if (string === void 0) { string = ""; }
    return string === "inj";
};
exports.isNativeDenomInjective = isNativeDenomInjective;
function isNativeCosmWasmDenom(chainId, address) {
    return ((utils_2.isTerraChain(chainId) && terra_1.isNativeDenom(address)) ||
        (chainId === utils_2.CHAIN_ID_INJECTIVE && exports.isNativeDenomInjective(address)));
}
exports.isNativeCosmWasmDenom = isNativeCosmWasmDenom;
function buildTokenId(chain, address) {
    var chainId = utils_2.coalesceCosmWasmChainId(chain);
    return ((isNativeCosmWasmDenom(chainId, address) ? "01" : "00") +
        utils_1.keccak256(Buffer.from(address, "utf-8")).substring(4));
}
exports.buildTokenId = buildTokenId;
