"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logNearGas = void 0;
var near_api_js_1 = __importDefault(require("near-api-js"));
function logNearGas(result, comment) {
    var _a = result.receipts_outcome.reduce(function (acc, receipt) {
        acc.totalGasBurned += receipt.outcome.gas_burnt;
        acc.totalTokensBurned += near_api_js_1.default.utils.format.formatNearAmount(receipt.outcome.tokens_burnt);
        return acc;
    }, {
        totalGasBurned: result.transaction_outcome.outcome.gas_burnt,
        totalTokensBurned: near_api_js_1.default.utils.format.formatNearAmount(result.transaction_outcome.outcome.tokens_burnt),
    }), totalGasBurned = _a.totalGasBurned, totalTokensBurned = _a.totalTokensBurned;
    console.log(comment, "totalGasBurned", totalGasBurned, "totalTokensBurned", totalTokensBurned);
}
exports.logNearGas = logNearGas;
