import { keccak256 } from "ethers/lib/utils";
import { isNativeDenom } from "../terra";
import { CHAIN_ID_INJECTIVE, coalesceCosmWasmChainId, isTerraChain, } from "../utils";
export var isNativeDenomInjective = function (string) {
    if (string === void 0) { string = ""; }
    return string === "inj";
};
export function isNativeCosmWasmDenom(chainId, address) {
    return ((isTerraChain(chainId) && isNativeDenom(address)) ||
        (chainId === CHAIN_ID_INJECTIVE && isNativeDenomInjective(address)));
}
export function buildTokenId(chain, address) {
    var chainId = coalesceCosmWasmChainId(chain);
    return ((isNativeCosmWasmDenom(chainId, address) ? "01" : "00") +
        keccak256(Buffer.from(address, "utf-8")).substring(4));
}
